#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#define DELKA_BUFFERU 128
#define BLACK 'x'
#define WHITE '.'
#define PRIPONA ".txt"
#define SOUBOR_VYSTUP "obnoveny.txt"

int cti_int(char *prompt)
{
  int cislo;
  printf("%s", prompt);
  while (scanf("%d", &cislo) != 1) {
    printf("Zadejte cele cislo: ");
    while (getchar() != '\n')
      ;
  }
  while (getchar() != '\n')
    ;
  return cislo;
}

int cti_kladne_int(char *prompt)
{
  int cislo;
  while ((cislo = cti_int(prompt)) < 0) {
    printf("Cislo musi byt kladne.\n");
  }
  return cislo;
}

char *precti_retezec(char *s, int max_delka)
{
  int delka;
  fgets(s, max_delka, stdin);
  delka = strlen(s) - 1;
  if (s[delka] == '\n')
    s[delka] = '\0';
  else
    while (getchar() != '\n')
      ;
  return s;
}

void inicializace(int *radek, int *sloupek, int ***x, int **p_x, int *****w, int ****p_p_p_w, int ***p_p_w, int **p_w)
{
  int i;
  *radek = cti_kladne_int("Kolik ma rastr radku? ");
  *sloupek = cti_kladne_int("Kolik ma rastr sloupku? ");
  if ((*p_x = (int *) malloc(*radek * *sloupek * sizeof(int))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  if ((*x = (int **) malloc(*radek * sizeof(int *))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  for (i = 0; i < *radek; i++) {
    (*x)[i] = *p_x + i * *sloupek;
  }
  if ((*p_w = (int *) calloc(*radek * *sloupek * *radek * *sloupek, sizeof(int))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  if ((*p_p_w = (int **) malloc(*radek * *sloupek * *radek * sizeof(int *))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  if ((*p_p_p_w = (int ***) malloc(*radek * *sloupek * sizeof(int **))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  if ((*w = (int ****) malloc(*radek * sizeof(int ***))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  for (i = 0; i < *radek * *sloupek * *radek; i++) {
    (*p_p_w)[i] = *p_w + i * *sloupek;
  }
  for (i = 0; i < *radek * *sloupek; i++) {
    (*p_p_p_w)[i] = *p_p_w + i * *radek;
  }
  for (i = 0; i < *radek; i++) {
    (*w)[i] = *p_p_p_w + i * *sloupek;
  }
}

void uvolni_pamet_pro_matici_int(int ***x, int **p_x)
{
  free((void *) *p_x);
  *p_x = NULL;
  free((void *) *x);
  *x = NULL;
}

void uvolni_pamet_pro_matici_matic_int(int *****x, int ****p_p_p_x, int ***p_p_x, int **p_x)
{
  free((void *) *p_x);
  *p_x = NULL;
  free((void *) *p_p_x);
  *p_p_x = NULL;
  free((void *) *p_p_p_x);
  *p_p_p_x = NULL;
  free((void *) *x);
  *x = NULL;
}

void trenuj(int radek, int sloupek, int **x, int ****w)
{
  const char *KONEC = "x";
  char buffer[DELKA_BUFFERU];
  FILE *fr;
  int i, j, k, l;
  char znak;
  bool chyba;
  do {
    printf("Zadejte jmeno souboru se vzorem bez pripony \"%s\", vstup \"%s\" ukoncuje zadavani: ", PRIPONA, KONEC);
    precti_retezec(buffer, sizeof(buffer));
    if (strcmp(buffer, KONEC) != 0) {
      strcat(buffer, PRIPONA);
      chyba = false;
      if ((fr = fopen(buffer, "r")) == NULL) {
        printf("Soubor %s se nepodarilo otevrit.\n", buffer);
        chyba = true;
      }
      for (i = 0; i < radek && !chyba; i++) {
        for (j = 0; j < sloupek && !chyba; j++) {
          if (fscanf(fr, "%c", &znak) != 1) {
            printf("Chybi hodnota v souboru %s!", buffer);
            chyba = true;
          }
          if (znak != BLACK && znak != WHITE) {
            printf("V souboru %s je neplatny znak '%c'!", buffer, znak);
            chyba = true;
          } else {
              x[i][j] = (znak == BLACK) ? 1 : -1;
            }
        }
        fscanf(fr, "%c", &znak);
      }
      if (fclose(fr) == EOF) {
        printf("Soubor %s se nepodarilo uzavrit.\n", buffer);
        chyba = true;
      }
      if (!chyba) {
        for (i = 0; i < radek; i++) {
          for (j = 0; j < sloupek; j++) {
            for (k = 0; k < radek; k++) {
              for (l = 0; l < sloupek; l++) {
                w[i][j][k][l] += x[i][j] * x[k][l];
              }
            }
          }
        }
      }
    }
  } while (strcmp(buffer, KONEC) != 0);
}

void obnov(int radek, int sloupek, int **x, int ****w)
{
  char buffer[DELKA_BUFFERU];
  FILE *fr, *fw;
  int i, j, k, l, n;
  char znak;
  bool chyba;
  int aktivace;
  int pocet_obnoveni = cti_kladne_int("Kolikrat se ma rastr obnovit? ");
  do {
    chyba = false;
    printf("Zadejte jmeno souboru s poskozenym vzorem bez pripony \"%s\": ", PRIPONA);
    precti_retezec(buffer, sizeof(buffer));
    strcat(buffer, PRIPONA);
    if ((fr = fopen(buffer, "r")) == NULL) {
      printf("Soubor %s se nepodarilo otevrit.\n", buffer);
      chyba = true;
    }
    for (i = 0; i < radek && !chyba; i++) {
      for (j = 0; j < sloupek && !chyba; j++) {
        if (fscanf(fr, "%c", &znak) != 1) {
          printf("Chybi hodnota v souboru %s!", buffer);
          chyba = true;
        }
        if (znak != BLACK && znak != WHITE) {
          printf("V souboru %s je neplatny znak '%c'!", buffer, znak);
          chyba = true;
        } else {
            x[i][j] = (znak == BLACK) ? 1 : -1;
          }
      }
      fscanf(fr, "%c", &znak);
    }
    if (fclose(fr) == EOF) {
      printf("Soubor %s se nepodarilo uzavrit.\n", buffer);
      chyba = true;
    }
    if (!chyba) {
      if ((fw = fopen(SOUBOR_VYSTUP, "w")) == NULL) {
        printf("Soubor %s se nepodarilo otevrit.\n", SOUBOR_VYSTUP);
        exit(1);
      }
      for (n = 0; n < pocet_obnoveni; n++) {
        fprintf(fw, "%u. obnoveni\n", n + 1);
        for (i = 0; i < radek; i++) {
          for (j = 0; j < sloupek; j++) {
            fprintf(fw, "%c", (x[i][j] >= 0) ? BLACK : WHITE);
          }
          fprintf(fw, "\n");
        }
        fprintf(fw, "\n");
        for (i = 0; i < radek; i++) {
          for (j = 0; j < sloupek; j++) {
            aktivace = 0;
            for (k = 0; k < radek; k++) {
              for (l = 0; l < sloupek; l++) {
                aktivace += x[k][l] * w[i][j][k][l];
              }
            }
            x[i][j] = (aktivace >= 0) ? 1 : -1;
          }
        }
      }
      if (fclose(fw) == EOF) {
        printf("Soubor %s se nepodarilo uzavrit.\n", SOUBOR_VYSTUP);
        exit(1);
      }
    }
  } while (chyba);
}

int main()
{
  int vyska_rastru, sirka_rastru;
  int **rastr, *p_rows;
  int ****vaha, ***p_rows_columns, **p_rows_columns_rows, *p_vahy;
  inicializace(&vyska_rastru, &sirka_rastru, &rastr, &p_rows, &vaha, &p_rows_columns, &p_rows_columns_rows, &p_vahy);
  trenuj(vyska_rastru, sirka_rastru, rastr, vaha);
  obnov(vyska_rastru, sirka_rastru, rastr, vaha);
  uvolni_pamet_pro_matici_int(&rastr, &p_rows);
  uvolni_pamet_pro_matici_matic_int(&vaha, &p_rows_columns, &p_rows_columns_rows, &p_vahy);
  printf("Vysledek je v souboru %s.\n", SOUBOR_VYSTUP);
  return 0;
}
/*Program Hopfieldova_sit;

uses crt, graph;

const r = 8;
      s = 6;

{const r = 24;
      s = 21;}

type Aktivace = -1..1;
     V = array [1..r, 1..s] of ShortInt;
     UkW = ^V;

var f : Text;
    fn : String [8];
    c : Char;
    a, i, j, k, l, n, GrDriver, GrMode, ErrCode : Integer;
    x : array [1..r, 1..s] of Aktivace;
    w : array [1..r, 1..s] of UkW;

procedure inicializace;
begin ClrScr;
      WriteLn ('Program "Hopfieldova s"');
      for i := 1 to r do for j := 1 to s do new (w [i,j]);
      for i := 1 to r do for j := 1 to s do
      for k := 1 to r do for l := 1 to s do w [i,j]^[k,l] := 0
end;

procedure trenuj;
begin fn := '';
      WriteLn ('Zadejte jmeno souboru se vzorem bez pripony .txt,');
      write ('vstup "x" ukoncuje zadavani: ');
      ReadLn (fn);
      while not (fn = 'x') do
      begin assign (f, fn + '.txt'); reset (f);
            for i := 1 to r do
            begin for j := 1 to s do
                  begin read (f, c);
                        if c = 'x' then x [i,j] := 1 else x [i,j] := -1;
                  end;
                  ReadLn (f)
            end;
            close (f);
            for i := 1 to r do for j := 1 to s do
            for k := 1 to r do for l := 1 to s do
            w [i,j]^[k,l] := w [i,j]^[k,l] + x [i,j] * x [k,l];
            WriteLn ('Zadejte jmeno souboru se vzorem bez pripony .txt,');
            write ('vstup "x" ukoncuje zadavani: ');
            ReadLn (fn);
      end;
end;

procedure obnov;
begin write ('Zadejte jmeno souboru s poskozenym vzorem bez pripony .txt : ');
      ReadLn (fn); assign (f, fn + '.txt'); reset (f);
      for i := 1 to r do
      begin for j := 1 to s do
            begin read (f, c);
                  if c = 'x' then x [i,j] := 1 else x [i,j] := -1;
            end;
            ReadLn (f)
      end;
      close (f);
      GrDriver := detect;
      InitGraph (GrDriver, GrMode,'');
      ErrCode := GraphResult;
      if ErrCode = GrOK then
      begin for i := 1 to r do for j := 1 to s do
            if x [i,j] = 1 then PutPixel (j, i, 15) else PutPixel (j, i, 0);
            c := ReadKey; n := 0;
            repeat for i := 1 to r do for j := 1 to s do
                   begin a := 0;
                         for k := 1 to r do for l := 1 to s do
                         a := a + x [k,l] * w [i,j]^[k,l];
                         if a >= 0 then
                         begin x [i,j] := 1;
                               PutPixel (j, i, 15)
                         end
                         else
                         begin x [i,j] := -1;
                               PutPixel (j, i, 0)
                         end;
                   end;
                   n := n + 1;
                   c := ReadKey;
            until c = #27;
            str (n, fn); OutTextXY (1, 470, 'Poet cykl: ' + fn);
            c := ReadKey;
      end
      else writeln('Chyba grafiky: ', GraphErrorMsg(ErrCode));
      for i := 1 to r do for j := 1 to s do dispose (w [i,j]);
end;

procedure vysledek;
begin assign (f, 'obnoveny.txt'); rewrite (f);
      for i := 1 to r do
      begin for j := 1 to s do
            if x [i,j] = 1 then write (f, 'x') else write (f, ' ');
            WriteLn (f)
      end;
      close (f)
end;

begin inicializace;
      trenuj;
      obnov;
      vysledek
end.*/
